// (C) 2003 Ulrich Hecht <uli@emulinks.de>
// Licensed under the terms of the GNU Public License version 2

#include "f2a.h"
#include <fcntl.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <unistd.h>

int f2a_readmem(char* file, int address, int size)
{
	int f,i;
	sendmsg sm;
	unsigned char data[1024];

	assert((size&1023)==0);

	memset(&sm, 0, sizeof(sm));

	f=open(file, O_WRONLY|O_CREAT,0666);

	sm.command=CMD_READDATA;
	sm.magic=MAGIC_NUMBER;
	sm.unknown=7;
	sm.address=address;
	sm.size=size;
	sm.sizekb=size/1024;
	if(sendf2a(sm)==-1) return -1;
	
	for(i=0;i<sm.sizekb;i++)
	{
		if(usb_read(data, 1024)==-1)
		{
			close(f);
			return -1;
		}
		if(write(f, data, 1024)==-1)
		{
			perror("unable to write data to file");
			close(f);
			return -1;
		}
	}
	close(f);
	return 0;
}
